#!/usr/bin/env perl
#;-*- Perl -*-

@ARGV == 1 || die "usage: con2pdb.pl <CONTCAR>\n";
$inputfilename = $ARGV[0];
$outputfilename = $inputfilename.".pdb";

$inputfile = "";
open(IN,$inputfilename);
while(<IN>) { $inputfile .= $_; }
close(IN);
@inputfile = split(/\n/,$inputfile);
foreach(@inputfile) { $_ =~ s/^\s+//; }

$descript = $inputfile[7];
$ntypes = $inputfile[5];
$natoms = $inputfile[6];
@natoms = split(/\s+/,$natoms);
@Ntypes= split(/\s+/,$ntypes);
$ntypes=$#Ntypes+1;
$totatoms = 0;
for($i=0; $i<$ntypes; $i++) {
    $totatoms += $natoms[$i];
}
if( $inputfile[8]=~/direct/i){
@comp=split(/\s+/,$inputfile[2]);
$scale=$inputfile[1];
@vx=@comp;
$norm=sqrt($comp[0]**2+$comp[1]**2+$comp[2]**2);
$fx=$inputfile[1]*$norm;
@comp=split(/\s+/,$inputfile[3]);
$norm=sqrt($comp[0]**2+$comp[1]**2+$comp[2]**2);
@vy=@comp;
$fy=$inputfile[1]*$norm;
@comp=split(/\s+/,$inputfile[4]);
@vz=@comp;
$norm=sqrt($comp[0]**2+$comp[1]**2+$comp[2]**2);
$fz=$inputfile[1]*$norm;
}
#$outfile = $totatoms."\n";
#$outfile .= "Generated with con2xyz\n";
$ln = 9;
$num=0;
for($type=0; $type<$ntypes; $type++) {
   if(0==1){ @line = split(/\s+/,$inputfile[$ln]);
    if(scalar(@line)>0) {
        $atype = @line[0];
    } else {
        $atype = "Type"."$type+1";
    }
    $ln += 2;}
    for($i=0; $i<$natoms[$type]; $i++) {
        $atype=$Ntypes[$type];
        @line = split(/\s+/,$inputfile[$ln]);
        $l[0]=$line[0]*$vx[0]+$line[1]*$vy[0]+$line[2]*$vz[0];
        $l[1]=$line[0]*$vx[1]+$line[1]*$vy[1]+$line[2]*$vz[1];
        $l[2]=$line[0]*$vx[2]+$line[1]*$vy[2]+$line[2]*$vz[2];
        $l[0]*=$scale;$l[1]*=$scale;$l[2]*=$scale;
        $outfile .= sprintf("%-6s%5d  %-3s %3s  %3d    %8.3f%8.3f%8.3f %5.2f %5.2f\n","ATOM",++$num, $atype, $atype, $num,@l[0..2],0.0, 0.0);
        $ln++;
    }
}
open (OUT,">$outputfilename");
print OUT $outfile;
close (OUT);

